<?php

namespace Teknisa\DF\Modules\Entrada\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DataSource\DataSet;


class ParamgeralPargeraldfe extends \Teknisa\DF\Controllers\TeknisaCrud {
    protected $dataSourceName = 'paramgeral_pargeraldfe';
    protected $entityManager;
    protected $environment;
    protected $cripto;
    

    public function __construct($crudService, $parameterBag, $environment, $entityManager, $cripto) {
        parent::__construct($crudService, $parameterBag);
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->cripto = $cripto;
    }

    public function save(DTO\Request $request, DTO\Response $response) {
   // $connection = $this->entityManager->getConnection();
//$connection->beginTransaction();
//var_dump($request);die; 
        try {
            $this->dataSourceName = "paramgeral";
            $campo1 = $request->getdataSet()->getRows()[0]['IDIMPAVLANNF'];
            $campo2 = $request->getdataSet()->getRows()[0]['IDBLAPRLCTMAPBL'];
            $array = array();
            $row = new Row();
            $row->set('__is_new',  false);
            $row->set('__createdLocal',true);
            $row->set('changed',true);
            $row->set('CDPARGERAL',  $request->getdataSet()->getRows()[0]['CDPARGERAL']);
            $row->set('IDNFOUTRASNF',  $request->getdataSet()->getRows()[0]['IDNFOUTRASNF']);
            $row->set('IDPERLANCNFOUFI',  $request->getdataSet()->getRows()[0]['IDPERLANCNFOUFI']);
            $row->set('IDPERAPROVNFXML',  $request->getdataSet()->getRows()[0]['IDPERAPROVNFXML']);
            $row->set('NRDECITOTANF',  $request->getdataSet()->getRows()[0]['NRDECITOTANF']);
            $row->set('VRFAIXTOLENF',  $request->getdataSet()->getRows()[0]['VRFAIXTOLENF']);
            $row->set('IDTPLANCDESC',  $request->getdataSet()->getRows()[0]['IDTPLANCDESC']);
            $row->set('IDPERALTCSTFENF',  $request->getdataSet()->getRows()[0]['IDPERALTCSTFENF']);
            $row->set('VRPETOLEVRAF',  $request->getdataSet()->getRows()[0]['VRPETOLEVRAF']);
            $row->set('IDCONSVLRMAF',  $request->getdataSet()->getRows()[0]['IDCONSVLRMAF']);
            $row->set('VRPETOLEQTAF',  $request->getdataSet()->getRows()[0]['VRPETOLEQTAF']);
            $row->set('IDCONSVLRMENAF',  $request->getdataSet()->getRows()[0]['IDCONSVLRMENAF']);
            $row->set('IDBLOQCMPSAF',  $request->getdataSet()->getRows()[0]['IDBLOQCMPSAF']);
            $row->set('IDUTBLOQOPAFPG',  $request->getdataSet()->getRows()[0]['IDUTBLOQOPAFPG']);
            $row->set('IDIMPFOVAZAF',  $request->getdataSet()->getRows()[0]['IDIMPFOVAZAF']);
            $row->set('IDAVNFNREPEN',  $request->getdataSet()->getRows()[0]['IDAVNFNREPEN']);
            $row->set('DSPARGERFIS',  $request->getdataSet()->getRows()[0]['DSPARGERFIS']);
            $row->set('IDAVNFNOCORR',  $request->getdataSet()->getRows()[0]['IDAVNFNOCORR']);
            $row->set('IDGERANFDEVO',  $request->getdataSet()->getRows()[0]['IDGERANFDEVO']);
            $row->set('NRMAXDIASIMPAF',  $request->getdataSet()->getRows()[0]['NRMAXDIASIMPAF']);
            $row->set('IDUTRELACFORNAF',  $request->getdataSet()->getRows()[0]['IDUTRELACFORNAF']);
            $row->set('NRDIASBLOQNF',  $request->getdataSet()->getRows()[0]['NRDIASBLOQNF']);
            $row->set('NRDIASAVISDTEMI',  $request->getdataSet()->getRows()[0]['NRDIASAVISDTEMI']);
            $row->set('NRDIASBLOQDTEMI',  $request->getdataSet()->getRows()[0]['NRDIASBLOQDTEMI']);
            $row->set('IDPARAMEMISRE',  $request->getdataSet()->getRows()[0]['IDPARAMEMISRE']);
            $row->set('IDOBRCHAVACES',  $request->getdataSet()->getRows()[0]['IDOBRCHAVACES']);
            $row->set('IDTPIMPNFE',  $request->getdataSet()->getRows()[0]['IDTPIMPNFE']);
            $row->set('IDGERNFIGUALXML',  $request->getdataSet()->getRows()[0]['IDGERNFIGUALXML']);
            $row->set('IDPELANIMPXML',  $request->getdataSet()->getRows()[0]['IDPELANIMPXML']);
            $row->set('IDPERVISIMPSCRE',  $request->getdataSet()->getRows()[0]['IDPERVISIMPSCRE']);
            $row->set('IDUTILNFELANCNF',  $request->getdataSet()->getRows()[0]['IDUTILNFELANCNF']);
            $row->set('IDBLOQALTPROXML',  $request->getdataSet()->getRows()[0]['IDBLOQALTPROXML']);
            $row->set('IDREAUDPARFISC',  $request->getdataSet()->getRows()[0]['IDREAUDPARFISC']);
            $row->set('IDBLOQAPRNFFORN',  $request->getdataSet()->getRows()[0]['IDBLOQAPRNFFORN']);
            $row->set('IDUTCTRLFISENTR',  $request->getdataSet()->getRows()[0]['IDUTCTRLFISENTR']);
            $row->set('IDVISUREGFISEMPR', $request->getdataSet()->getRows()[0]['IDVISUREGFISEMPR']);
            $row->set('NRORG', $this->environment->getNrOrgTrab());
            $array[] = $row;
            $dataSet = new DataSet('paramgeral', $array);
            $request2 = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
            $rows = $this->crudService->getRowsToSave($request2, $dataSourceName);
            $this->crudService->save($dataSourceName, $rows);
            $this->inserirParametrosGeralDFE($campo1,$campo2,$response,$request);

        } catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }
    }
    public function inserirParametrosGeralDFE($campo1,$campo2,$response,$request){
        $this->dataSourceName = "pargeraldfe";
        $this->dataSourceNameToSave = "pargeraldfe";
        $dataSourceName = $this->dataSourceNameToSave ? $this->dataSourceNameToSave : $this->dataSourceName;
        $condicaoAdicional = $this->retornaCondicao();
        $resul = $this->realizaConsulta($response,$condicaoAdicional);
        $resul = $resul->getDataSets()[0]->getRows();
        $array = array();
            $row = new Row();
            if(empty($resul)){
                $row->set('__is_new',true);
            }else{
                $row->set('__is_new',false);
            }
            $row->set('__createdLocal',true);
            $row->set('changed',true);
            $row->set('IDIMPAVLANNF', $campo1);
            $row->set('IDBLAPRLCTMAPBL', $campo2);
            $row->set('CDPARAMDFE', '1');
            $row->set('DSLOGINSMTPGENTR', $request->getdataSet()->getRows()[0]['DSLOGINSMTPGENTR']);
            $row->set('DSSMTPEMAILFGENTR', $request->getdataSet()->getRows()[0]['DSSMTPEMAILFGENTR']);
            $rowDoDataset2 = $request->getdataSet()->getRows();
            $camposDaRow2 = $rowDoDataset2[0];
            $boolSenhaAlterada = $camposDaRow2['senhaSMTPEntrAlterada'];
            //var_dump($boolSenhaAlterada);die;
            if($boolSenhaAlterada){
                $valorDescriptografado = $request->getdataSet()->getRows()[0]['CDSENHEMAILFGENTR'];
                //var_dump($valorDescriptografado);die;
                $valorCriptografado = $this->cripto->cripto($valorDescriptografado,2);
                $row->set('CDSENHEMAILFGENTR', $valorCriptografado);
            }else{
               $row->set('CDSENHEMAILFGENTR', $request->getdataSet()->getRows()[0]['CDSENHEMAILFGENTR']);
            }
            $row->set('IDUTTLSEMAILGENTR', $request->getdataSet()->getRows()[0]['IDUTTLSEMAILGENTR']);
            $row->set('IDUTSSLEMAILGENTR', $request->getdataSet()->getRows()[0]['IDUTSSLEMAILGENTR']);
            
            
            // $row->set('DSLOGINSMTPGSAID',  $request->getdataSet()->getRows()[0]['DSLOGINSMTPGSAID']);
            // $row->set('DSSMTPEMAILFGSAID', $request->getdataSet()->getRows()[0]['DSSMTPEMAILFGSAID']);
            // $rowDoDataset2 = $request->getdataSet()->getRows();
            // $camposDaRow2 = $rowDoDataset2[0];
            // //$boolSenhaAlterada = $camposDaRow2['senhaSMTPSaidaAlterada'];
            // //var_dump($boolSenhaAlterada);die;
            // if($boolSenhaAlterada){
            //     $valorDescriptografado = $request->getdataSet()->getRows()[0]['CDSENHEMAILFGSAID'];
            //     //var_dump($valorDescriptografado);die;
            //     $valorCriptografado = $this->cripto->cripto($valorDescriptografado,2);
            //     $row->set('CDSENHEMAILFGSAID', $valorCriptografado);
            // }else{
            //   $row->set('CDSENHEMAILFGSAID', $request->getdataSet()->getRows()[0]['CDSENHEMAILFGSAID']);
            // }
            // $row->set('IDUTTLSEMAILGSAID', $request->getdataSet()->getRows()[0]['IDUTTLSEMAILGSAID']);
            // $row->set('IDUTSSLEMAILGSAID', $request->getdataSet()->getRows()[0]['IDUTSSLEMAILGSAID']);
             
            $row->set('NRORG', $this->environment->getNrOrgTrab());
            
        $array[] = $row;

        try {
            $dataSet = new DataSet('pargeraldfe', $array);
            $request3 = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            $saveRows = $this->crudService->getRowsToSave($request3,$dataSourceName);
            //var_dump($saveRows);die;
            $this->crudService->save('pargeraldfe', $saveRows);
            
        }catch (\Exception $e) {
            $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
        }

    }
    public function realizaConsulta($response,$conditions) {
        $filterCriteria = new FilterCriteria($this->dataSourceName,$conditions);
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $this->crudService->find($response,$newFilterCriteria);
        
        return $response;
    }
    public function retornaCondicao() {
        $conditions = array(
            array(
                "value" => $this->environment->getNrOrgTrab(),
                "operator" => "=",
                "columnName" => "NRORG"
            )
        );
        return $conditions;
    }
    
}